Index: EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/componentobj.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/componentobj.rb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/componentobj.rb	(revision 429)
@@ -2730,72 +3053,111 @@
   #=== Cell#restrict を追加
   def add_restrict( entry_name, func_name, region_name_list )
-    if @restrict_list[ entry_name ] then
-      if @restrict_list[ entry_name ][ func_name ] then
-        @restrict_list[ entry_name ][ func_name ].each{ |rn|
-          if region_name_list.include? rn then
-            # p func_name
-            name = func_name ? entry_name : entry_name+"."+func_name
-            cdl_warning( "W9999 $1 restrict region duplicate $2", name, rn )
+    if @restrict_list[ entry_name ] == nil then
+      @restrict_list[ entry_name ] = {}
+      @restrict_list2[ entry_name ] = {}
+    end
+    if @restrict_list[ entry_name ][ func_name ] == nil then
+      @restrict_list[ entry_name ][ func_name ] = []
+      @restrict_list2[ entry_name ][ func_name ] = []
+    end
+    region_name_list.each { |rp|
+      @restrict_list[ entry_name ][ func_name ] << rp
+      # p "Class: " + rp.to_s
+      obj = Namespace.find rp
+      if ( obj.kind_of? Region ) then
+        @restrict_list2[ entry_name ][ func_name ] << obj.get_domain_root
+      else
+        cdl_error( "S9999 $1 not found or not region", rp.to_s )
+      end
+    }
+  end
+
+  #=== Cell#check_restrict_list
+  def check_restrict_list
+    # p "check_restrict_list"
+    @restrict_list.each{ |entry_name, func_hash|
+      func_hash.each{ |func_name, region_list|
+        region_list.each{ |rp|
+          obj = Namespace.find rp
+          if ( obj.kind_of? Region ) then
+            if obj.get_domain_root != @region.get_domain_root then
+            else
+              cdl_info( "I9999 $1: restrict calling domain to $2, which is same domain as the cell locates", @name, rp.to_s )
+              # restrict を同じドメインを指定してもよいこととする (HRP3)
+              # KernelDoamin 内のセルに対し、KernelDomain に restrict している場合、
+              # 無所属経由で結合されているが、KernelDomain から呼出すことを想定した許可
+            end
+          else
+            cdl_error( "S9999 $1 not region", rp.to_s )
+          end
+        }
+      }
+    }
+  end
+
+  #=== Cell#callable?
+  def callable?( callee_cell, entry_name, func_name )
+    # p "callable? #{@name}"
+    res = callee_cell.callable_from?( entry_name, func_name, self )
+    dbgPrint "callable? #{callee_cell.get_namespace_path}.#{entry_name}.#{func_name} from #{@NamespacePath} is #{res}\n"
+    return res
+  end
+
+  #=== Cell#callable_from? (private)
+  def callable_from?( entry_name, func_name, caller_cell )
+    @b_restrict_referenced = true
+    if @restrict_list.length == 0 then
+      return true
+    end
+
+    dr = caller_cell.get_region.get_domain_root
+    if @restrict_list[entry_name] then
+      if @restrict_list[entry_name][func_name] then
+        @restrict_list2[entry_name][func_name].each{ |region|
+          if dr == region then
+            return true
+          end
+        }
+      elsif @restrict_list[entry_name][nil] then
+        @restrict_list2[entry_name][nil].each{ |region|
+          if dr == region then
+            return true
           end
         }
       else
-        @restrict_list[ entry_name ][ func_name ] = region_name_list
-      end
-    else
-      func_list = { }
-      func_list[ func_name ] = region_name_list
-      @restrict_list[ entry_name ] = func_list
-    end
-    # pp @restrict_list
-  end
-
-  #=== Cell#check_restrict_list
-  def check_restrict_list
-    @restrict_list.each{ |entry_name, func_hash|
-      func_hash.each{ |func_name, region_list|
-        region_list.each{ |rn|
-          obj = Namespace.find [ rn ]
-          if ( obj.kind_of? Region ) then
-            if obj.get_domain_root != @region.get_domain_root then
-            else
-              cdl_warning( "W9999 $1 in same domain", rn )
-            end
-          else
-            cdl_error( "S9999 $1 not region", region )
-          end
-        }
-      }
-    }
-  end
-
-  #=== Cell#callable?
-  def callable?( callee_cell, entry_name, func_name )
-    res = callee_cell.callable_from?( entry_name, func_name, self )
-    dbgPrint "callable? #{callee_cell.get_namespace_path}.#{entry_name}.#{func_name} from #{@NamespacePath} is #{res}\n"
-    return res
-  end
-
-  #=== Cell#callable_from? (private)
-  def callable_from?( entry_name, func_name, caller_cell )
-    if @restrict_list.length == 0 then
+        return false
+      end
+    else
+      return false
+    end
+  end
+
+  #=== Cell#get_callable_regions( entry_name, func_name )
+  # func_name=nil の場合、entry_name の可否をチェック数る
+  # nil が返る場合、制限されていないことを意味する
+  def get_restricted_regions( entry_name, func_name )
+    # p "get_restricted_regions #{@name}"
+    @b_restrict_referenced = true
+    if @restrict_list[entry_name] then
+      if @restrict_list[entry_name][func_name] then
+        return @restrict_list2[entry_name][func_name]
+      else
+        return @restrict_list2[entry_name][nil]
+      end
+    end
+    return nil
+  end
+
+  #=== Cell#has_ineffective_restrict_specifier
+  # restrict 指定子が指定されていて、参照されていない場合 true
+  # 参照は、HRPSVCPlugin のみ
+  def has_ineffective_restrict_specifier
+    if @restrict_list.length != 0 && @b_restrict_referenced == false then
       return true
-    end
-
-    if @restrict_list[entry_name] then
-      if @restrict_list[entry_name][nil] &&
-         @restrict_list[entry_name][nil].include?( caller_cell.get_region.get_domain_root.get_name )then
-        return true
-      end
-      if @restrict_list[entry_name][func_name] &&
-         @restrict_list[entry_name][func_name].include?( caller_cell.get_region.get_domain_root.get_name )then
-        return true
-      else
-        return false
-      end
-    else
-      return true
-    end
-  end
-  
+    else
+      return false
+    end
+  end
+
   def show_tree( indent )
     indent.times { print "  " }
@@ -2857,5 +3219,6 @@
 # @name:: str
 # @global_name:: str
-# @cell_list:: NamedList   Cell
+# @cell_list_in_composite:: NamedList   Cell
+# @cell_list::Array :: [ Cell ] : cell of CompositeCelltype's cell
 # @export_name_list:: NamedList : CompositeCelltypeJoin
 # @port_list:: CompositeCelltypeJoin[]
@@ -2867,8 +3230,13 @@
 # @name_list:: NamedList item: Decl (attribute), Port エクスポート定義
 # @internal_allocator_list:: [ [cell, internal_cp_name, port_name, func_name, param_name, ext_alloc_ent], ... ]
+# @generate:: [ Symbol, String, Plugin ]  = [ PluginName, option, Plugin ] Plugin は生成後に追加される
+# @generate_list:: [ [ Symbol, String, Plugin ], ... ]   generate 文で追加された generate
 
   @@nest_stack_index = -1
   @@nest_stack = []
   @@current_object = nil
+
+  include CelltypePluginModule
+  include PluginModule
 
   def self.push
@@ -2889,5 +3257,6 @@
     super()
     @name = name
-    @cell_list = NamedList.new( nil, "in composite celltype #{name}" )
+    @cell_list_in_composite = NamedList.new( nil, "in composite celltype #{name}" )
+    @cell_list = []
     @export_name_list = NamedList.new( nil, "export in composite celltype #{name}" )
     @name_list = NamedList.new( nil, "in composite celltype #{name}" )
@@ -2910,4 +3279,5 @@
     @attr_list = []
     @internal_allocator_list = []
+    @generate_list = []
     set_specifier_list( Generator.get_statement_specifier )
   end
@@ -2920,5 +3290,4 @@
   # CompositeCelltype#end_of_parse
   def end_of_parse
-
     # singleton に関するチェック
     if @b_singleton && @real_singleton == nil then
@@ -2960,11 +3329,19 @@
     # mikan relay が正しく抜けているかチェックされていない
 
+    # callback 結合
+    @cell_list_in_composite.get_items.each{ |c|
+      ct = c.get_celltype
+      if ct then
+        c.create_reverse_join
+      end
+    }
+
     # 意味解析
-    @cell_list.get_items.each{ |c|
+    @cell_list_in_composite.get_items.each{ |c|
       c.set_definition_join
     }
 
     # cell の未結合の呼び口がないかチェック
-    @cell_list.get_items.each{ |c|
+    @cell_list_in_composite.get_items.each{ |c|
       c.check_join
       c.check_reverse_require
@@ -3004,15 +3381,20 @@
       }
     }
-  end
-
- ### cell (CompositeCelltype)
-  def self.new_cell( cell )
-    @@current_object.new_cell( cell )
-
-  end
-
-  def new_cell( cell )
+
+    # composite プラグイン
+    if @generate then
+      celltype_plugin
+    end
+  end
+
+ ### CompositeCelltype#new_cell_in_composite
+  def self.new_cell_in_composite( cell )
+    @@current_object.new_cell_in_composite( cell )
+
+  end
+
+  def new_cell_in_composite( cell )
     cell.set_owner self  # Cell (in_omposite)
-    @cell_list.add_item( cell )
+    @cell_list_in_composite.add_item( cell )
     if cell.get_celltype then    # nil ならば、すでにセルタイプなしエラー
       if cell.get_celltype.is_singleton? then
@@ -3031,4 +3413,12 @@
 					 internal_cell_elem_name, type )
     
+  end
+
+ ### CompositeCelltype#new_cell
+  def new_cell cell
+    @cell_list << cell
+
+    # セルタイププラグインの適用
+    celltype_plugin_new_cell cell
   end
 
@@ -3050,5 +3440,5 @@
     dbgPrint "new_join: #{export_name} #{internal_cell_name} #{internal_cell_elem_name}\n"
 
-    cell = @cell_list.get_item( internal_cell_name )
+    cell = @cell_list_in_composite.get_item( internal_cell_name )
     if cell == nil then
       cdl_error( "S1057 $1 not found in $2" , internal_cell_name, @name )
@@ -3107,4 +3497,8 @@
         elsif obj.is_omit? != obj2.is_omit? then
           cdl_error( "S9999 $1 : omit specifier mismatch with previous definition" , export_name )
+        elsif obj.is_dynamic? != obj2.is_dynamic? then
+          cdl_error( "S9999 $1 : dynamic specifier mismatch with previous definition" , export_name )
+        elsif obj.is_ref_desc? != obj2.is_ref_desc? then
+          cdl_error( "S9999 $1 : ref_desc specifier mismatch with previous definition" , export_name )
         end
       else
@@ -3292,5 +3686,5 @@
   def find name
     dbgPrint "CompositeCelltype: find in composite: #{name}\n"
-    cell = @cell_list.get_item( name )
+    cell = @cell_list_in_composite.get_item( name )
     return cell if cell
 
@@ -3333,7 +3727,8 @@
     clone_cell_list = {}
     clone_cell_list2 = []
+    clone_cell_list3 = {}
 
     #  composite 内部のすべての cell について
-    @cell_list.get_items.each { |c|
+    @cell_list_in_composite.get_items.each { |c|
 
       # debug
@@ -3359,5 +3754,5 @@
           # debug
           if j then
-            dbgPrint "expand : parent cell: #{name} child cell: #{c.get_name}:  parent's export port: #{cj.get_name}  join: #{j.get_name} #{j}\n"
+            dbgPrint "  REWRITE_EX parent cell: #{name} child cell: #{c.get_name}:  parent's export port: #{cj.get_name}  join: #{j.get_name}=>#{j.get_rhs.to_s}\n"
           else
             dbgPrint "expand : parent cell: #{name} child cell: #{c.get_name}:  parent's export port: #{cj.get_name}  join: nil\n"
@@ -3394,4 +3789,5 @@
       clone_cell_list[ "#{c.get_local_name}" ] = c2
       clone_cell_list2 << c2
+      clone_cell_list3[ c ] = c2
 
     }
@@ -3403,4 +3799,9 @@
         j.set_cloned( clone_cell_list[ "#{c.get_local_name}" ] )
       }
+      dbgPrint "change_rhs_port: inner cell #{c.get_name}\n"
+      c.change_rhs_port clone_cell_list3
+    }
+    clone_cell_list2.each { |c|
+      c.expand_inner
     }
     return [ clone_cell_list, clone_cell_list2 ]
@@ -3419,4 +3820,9 @@
       when :ACTIVE
         @b_active = true
+      when :GENERATE
+        if @generate then
+          cdl_error( "S9999 generate specifier duplicate"  )
+        end
+        @generate = [ s[1], s[2] ] # [ PluginName, "option" ]
       else
         cdl_error( "S1071 $1 cannot be specified for composite" , s[0] )
@@ -3429,4 +3835,8 @@
   end
 
+  def get_global_name
+    @global_name
+  end
+
   def get_port_list
     @port_list
@@ -3443,4 +3853,16 @@
   def get_internal_allocator_list
     @internal_allocator_list
+  end
+
+  #== CompositeCelltype#get_real_celltype
+  # port_name に接続されている内部のセルタイプを得る
+  def get_real_celltype( port_name )
+    cj = find_export port_name
+    inner_celltype = cj.get_cell.get_celltype
+    if inner_celltype.instance_of? CompositeCelltype then
+      return inner_celltype.get_real_celltype
+    else
+      return inner_celltype
+    end
   end
 
@@ -3465,5 +3887,5 @@
   def is_inactive?
     if @b_active == false then
-      @cell_list.get_items.each{ |c|
+      @cell_list_in_composite.get_items.each{ |c|
         if c.get_celltype && c.get_celltype.is_inactive? == false then
           # c.get_celltype == nil の場合はセルタイプ未定義ですでにエラー
@@ -3486,5 +3908,5 @@
     (indent+1).times { print "  " }
     puts "active: #{@b_active}, singleton: #{@b_singleton}"
-    @cell_list.show_tree( indent + 1 )
+    @cell_list_in_composite.show_tree( indent + 1 )
     (indent+1).times { print "  " }
     puts "name_list"
@@ -3532,5 +3954,5 @@
 # @b_omit:: bool : omit 指定子が指定された (call port のみ)
 # @b_optional:: bool : call port のみ
-# @b_ref_des:: bool :  ref_desc キーワードが指定された
+# @b_ref_desc:: bool :  ref_desc キーワードが指定された
 # @b_dynamic:: bool :  dynamic キーワードが指定された (呼び口のみ)
 #
@@ -3638,4 +4060,5 @@
     @b_inline = false
     @b_optional = false
+    @b_omit = false
     @b_ref_desc = false
     @b_dynamic = false
@@ -3655,5 +4078,5 @@
     else
       # entry port optimize
-      if $unopt then
+      if $unopt || $unopt_entry then
         # 最適化なし
         @b_VMT_useless = false                     # VMT 不要 (true の時 VMT を介することなく呼出す)
@@ -3786,4 +4209,8 @@
         @b_optional = true
       when :REF_DESC
+        if @port_type == :ENTRY then
+          cdl_error( "S9999 ref_desc: cannnot be specified for entry port" )
+          next
+        end
         @b_ref_desc = true
       when :DYNAMIC
@@ -3806,4 +4233,21 @@
       end
     }
+    if ( @b_dynamic || @b_ref_desc ) then
+      if @b_dynamic then
+        dyn_ref = "dynamic"
+      else
+        dyn_ref = "ref_desc"
+      end
+      if @b_omit then     # is_omit? は is_empty? も含んでいるので使えない
+        cdl_error( "S9999 omit cannot be specified with $1", dyn_ref  )
+      elsif @signature && @signature.is_empty? then
+        cdl_error( "S9999 $1 cannot be specified for empty signature", dyn_ref  )
+      elsif @signature && @signature.has_descriptor? then
+        # cdl_error( "S9999 $1 port '$2' cannot have Descriptor in its signature", dyn_ref, @name )
+      end
+
+    elsif @b_dynamic && @b_ref_desc then
+      cdl_error( "S9999 both dynamic & ref_desc cannot be specified simultaneously"  )
+    end
   end
 
@@ -3958,9 +4402,21 @@
 
   def is_VMT_useless?                     # VMT 関数テーブルを使用しない
-   @b_VMT_useless
+    if @port_type == :ENTRY && $unopt_entry == true then
+      # プラグインから $unopt_entry を設定するケースのため
+      # ここで読み出すときに、false を返す (reset_optimize での設定変更は速すぎる)
+      return false
+    else
+      return @b_VMT_useless
+    end
   end
 
   def is_skelton_useless?                 # スケルトン関数不要   (true の時、受け口関数を呼出す)
-    @b_skelton_useless
+    if @port_type == :ENTRY && $unopt_entry == true then
+      # プラグインから $unopt_entry を設定するケースのため
+      # ここで読み出すときに、false を返す (reset_optimize での設定変更は速すぎる)
+      return false
+    else
+      return @b_skelton_useless
+    end
   end
 
@@ -4078,4 +4534,14 @@
   def is_reverse_required?
     @reverse_require_cell_path != nil
+  end
+
+  #=== Port# is_dynamic?
+  def is_dynamic?
+    @b_dynamic
+  end
+
+  #=== Port# is_ref_desc?
+  def is_ref_desc?
+    @b_ref_desc
   end
 
@@ -4489,7 +4955,7 @@
       if ! c.get_f_def then   # Namespace の @cell_list にはプロトタイプが含まれるケースあり
         if c.get_f_ref then
-          cdl_error( "S1093 $1 : undefined cell" , c.get_namespace_path.get_path_str )
+          c.cdl_error( "S1093 $1 : undefined cell" , c.get_namespace_path.get_path_str )
         elsif $verbose then
-          cdl_warning( "W1006 $1 : only prototype, unused and undefined cell" , c.get_namespace_path.get_path_str )
+          c.cdl_warning( "W1006 $1 : only prototype, unused and undefined cell" , c.get_namespace_path.get_path_str )
         end
       else
@@ -4498,5 +4964,8 @@
         # if c.get_f_ref == false && c.is_generate? && ct && ct.is_inactive? then
         if c.get_f_ref == false && ct && ct.is_inactive? then
-          cdl_warning( "W1007 $1 : non-active cell has no entry join and no factory" , c.get_namespace_path.get_path_str )
+          c.cdl_warning( "W1007 $1 : non-active cell has no entry join and no factory" , c.get_namespace_path.get_path_str )
+        end
+        if c.has_ineffective_restrict_specifier then
+          c.cdl_warning( "W9999: $1 has ineffective restrict specifier", c.get_namespace_path.get_path_str )
         end
       end
@@ -4657,4 +5126,16 @@
   end
 
+  #=== Namespace# set_max_entry_port_inner_cell
+  # セルタイプに属するすべてのセルに対して実施
+  def set_max_entry_port_inner_cell
+    # celltype のコードを生成
+    @cell_list.each { |c|
+      c.set_max_entry_port_inner_cell
+    }
+    @namespace_list.each{ |ns|
+      ns.set_max_entry_port_inner_cell
+    }
+  end
+
   #=== Namespace# セルの結合をチェックする
   def check_join
@@ -4681,4 +5162,16 @@
   end
 
+  #== Namespace (Region) に属するセルのリスト
+  def get_cell_list
+    @cell_list
+  end
+
+  #== Namespace (Region)# 子リージョンのリスト
+  #
+  # リージョンは Namespace クラスで namespace として記憶されている
+  def get_region_list
+    @namespace_list
+  end
+  
   def show_tree( indent )
     indent.times { print "  " }
@@ -4904,7 +5397,7 @@
 
     if object == nil then                                             # (2)
-      cdl_error( "S1109 \'$1\' not found" , @cell_name )
+      cdl_error( "S1109 \'$1\' not found" , nsp.to_s )
     elsif ! object.instance_of?( Cell ) then                          # (3)
-      cdl_error( "S1110 \'$1\' not cell" , @cell_name )
+      cdl_error( "S1110 \'$1\' not cell" , nsp.to_s )
     else
       dbgPrint "set_definition: set_f_ref #{@owner.get_name}.#{@name} => #{object.get_name}\n"
@@ -5277,4 +5770,5 @@
           next_cell_nsp       = @through_generated_list[ i + 1 ].get_cell_namespace_path
           next_port_name      = @through_generated_list[ i + 1 ].get_through_entry_port_name
+          next_port_subscript = @through_generated_list[ i + 1 ].get_through_entry_port_subscript
         rescue Exception => evar
           cdl_error( "S1124 $1: plugin function failed: \'get_through_entry_port_name\'" , plugin_name )
@@ -5295,4 +5789,5 @@
         next_cell      = @cell
         next_port_name = @port_name
+        next_port_subscript = @rhs_subscript
 
         if next_cell == nil then
@@ -5306,5 +5801,5 @@
         # region から @cell_name.@port_name への through がないか探す
         # rp = @through_list[i][3].find_cell_port_through_plugin( @cell_name, @port_name ) #762
-        rp = @through_list[i][3].find_cell_port_through_plugin( @cell.get_global_name, @port_name )
+        rp = @through_list[i][3].find_cell_port_through_plugin( @cell.get_global_name, @port_name, @rhs_subscript )
            # @through_list[i] と @region_through_list[i-cp_len] は同じ
         # 共用しないようにするには、見つからなかったことにすればよい
@@ -5317,6 +5812,7 @@
 
       if rp == nil then
-        if( load_plugin( plugin_name, ThroughPlugin ) ) then
-          gen_through_cell_code_and_parse( plugin_name, i, next_cell, next_port_name )
+        plClass = load_plugin( plugin_name, ThroughPlugin )
+        if( plClass ) then
+          gen_through_cell_code_and_parse( plugin_name, i, next_cell, next_port_name, next_port_subscript, plClass )
         end
       else
@@ -5331,5 +5827,5 @@
           # 生成したものを region(@through_list[i][3]) のリストに追加
           # @through_list[i][3].add_cell_port_through_plugin( @cell_name, @port_name, @through_generated_list[i] ) #762
-          @through_list[i][3].add_cell_port_through_plugin( @cell.get_global_name, @port_name, @through_generated_list[i] )
+          @through_list[i][3].add_cell_port_through_plugin( @cell.get_global_name, @port_name, @rhs_subscript, @through_generated_list[i] )
         end
       end
@@ -5365,5 +5861,5 @@
 
   #=== Join# through プラグインを呼び出して CDL 生成させるとともに、import する
-  def gen_through_cell_code_and_parse( plugin_name, i, next_cell, next_port_name )
+  def gen_through_cell_code_and_parse( plugin_name, i, next_cell, next_port_name, next_port_subscript, plClass )
 
     through = @through_list[ i ]
@@ -5389,15 +5885,10 @@
     end
     @@plugin_creating_join = self
-
     caller_cell = @owner
 
-    plugin_object = nil
-    eval_str = "plugin_object = #{plugin_name}.new( '#{generating_cell_name}'.to_sym, plugin_arg.to_s, next_cell, '#{next_port_name}'.to_sym, @definition.get_signature, @celltype, caller_cell )"
-    if $verbose then
-      print "new through: #{eval_str}\n"
-    end
-
     begin
-      eval( eval_str )     # plugin を生成
+      plugin_object = plClass.new( generating_cell_name.to_sym, plugin_arg.to_s,
+                                   next_cell, next_port_name.to_sym, next_port_subscript,
+                                   @definition.get_signature, @celltype, caller_cell )
       plugin_object.set_locale @locale
     rescue Exception => evar
@@ -5406,6 +5897,4 @@
         print "signature: #{@definition.get_signature.get_name} from: #{caller_cell.get_name} to: #{next_cell.get_name} of celltype: #{@celltype.get_name}\n"
       end
-      print "eval( #{eval_str} )\n"
-
       print_exception( evar )
       return 
@@ -5596,5 +6085,12 @@
   end
 
-  def get_rhs_subscript
+  # 末尾数字1 : CDL で指定された、右辺のセルを返す
+  def get_rhs_cell1   # get_cell と同じ
+    @cell
+  end
+  def get_rhs_port1   # get_port_name 同じ
+    @port_name
+  end
+  def get_rhs_subscript1
     @rhs_subscript
   end
@@ -5606,7 +6102,5 @@
     # through 指定あり？
     if @through_list[0] then
-      # mikan through で生成したものが root namespace 限定
       # through で生成されたセルを探す
-#      cell = Namespace.find( [ "::", @through_generated_list[0].get_cell_name.to_sym ] )    #1
       cell = Namespace.find( @through_generated_list[0].get_cell_namespace_path )    #1
       # cell のプラグインで生成されたポート名のポートを探す (composite なら内部の繋がるポート)
@@ -5615,4 +6109,16 @@
       # ポートを返す(composite なら内部の繋がるポートを返す)
       return @cell.get_real_port( @port_name )
+    end
+  end
+
+  #=== Join# 右辺の配列添数を得る
+  #    右辺が through の場合は挿入されたセルの添数
+  #    右辺が composite の場合は、内部の繋がるセルのポートの添数 (composite では変わらない)
+  #    このメソッドは get_rhs_cell,  と対になっている
+  def get_rhs_subscript
+    if @through_list[0] then
+      return @through_generated_list[0].get_through_entry_port_subscript
+    else
+      return @rhs_subscript
     end
   end
@@ -5718,12 +6224,18 @@
   # composite cell を展開したセルの結合を clone したセルの名前に変更
   def change_rhs_port( clone_cell_list, celltype )
+    dbgPrint "change_rhs_port: name=#{@name}\n"
 
     # debug
     if $debug then
-      dbgPrint "change_rhs name: #{@name}  cell_name: #{@cell_name} #{@cell} #{self}\n"
+#    if @name == :cCallB then
+      # dbgPrint "change_rhs name: #{@name}  cell_name: #{@cell_name} #{@cell} #{self}\n"
+      print "============\n"
+      print "CHANGE_RHS change_rhs name: #{@owner.get_name}.#{@name}  rhs cell_name: #{@cell_name} #{@cell} #{self}\n"
 
       clone_cell_list.each{ |cell, ce|
-        dbgPrint "change_rhs:  #{cell.get_name}=#{cell} : #{ce.get_name}\n"
+        # dbgPrint "=== change_rhs:  #{cell.get_name}=#{cell} : #{ce.get_name}\n"
+        print "   CHANGE_RHS  change_rhs:  #{cell.get_name}=#{cell} : #{ce.get_name}\n"
       }
+      print "============\n"
     end
 
@@ -5732,5 +6244,5 @@
 
     # debug
-    dbgPrint "  cell_name:   #{@cell_name} => #{c.get_global_name}, #{c.get_name}\n"
+    dbgPrint "  REWRITE cell_name:  #{@owner.get_name}   #{@cell_name} => #{c.get_global_name}, #{c.get_name}\n"
 
     # @rhs の内容を調整しておく（この内容は、subscript を除いて、後から使われていない）
@@ -5756,5 +6268,5 @@
 
       # debug
-      # p "array_member2.len : #{@array_member.length}"
+      dbgPrint "array_member2.len : #{@array_member.length}\n"
 
       i = 0
@@ -5764,4 +6276,5 @@
         # 無駄に設定されているものについては、再帰的に呼び出す必要はない（clone_for_composite では対策している）
         if @array_member2[i] != self && @array_member[i] != nil then
+          dbgPrint "change_rhs array_member #{i}: #{@name}  #{@cell_name}\n"
           @array_member2[i].change_rhs_port( clone_cell_list, celltype )
         end
@@ -5779,11 +6292,10 @@
   # @through_list などもコピーされるので、これが呼び出される前に確定する必要がある
   def clone_for_composite( ct_name, cell_name, locale, b_need_recursive = true )
-
     # debug
-    dbgPrint "join.clone_for_composite : #{@name} #{@cell_name} #{self}\n"
+    dbgPrint "=====  clone_for_composite: #{@name} #{@cell_name} #{self}   =====\n"
     cl = self.clone
 
     if @array_member2 && b_need_recursive then
-      cl.clone_array_member( @array_member, @array_member2, ct_name, cell_name, self, locale )
+      cl.clone_array_member( ct_name, cell_name, self, locale )
     end
 
@@ -5796,17 +6308,20 @@
   end
 
-  def clone_array_member( array_member, array_member2, ct_name, cell_name, prev, locale )
+  def clone_array_member( ct_name, cell_name, prev, locale )
     # 配列のコピーを作る
-    am  = array_member.clone
-    am2 = array_member2.clone
+    am  = @array_member.clone
+    am2 = @array_member2.clone
 
     # 配列要素のコピーを作る
     i = 0
     while i < am2.length
-      if array_member2[i] == prev then
+      if @array_member2[i] == prev then
         # 自分自身である（ので、呼出すと無限再帰呼出しとなる）
         am2[i] = self
-      elsif array_member2[i] then
-        am2[i] = array_member2[i].clone_for_composite( ct_name, cell_name, locale, false )
+        am[i] = am2[i].get_rhs
+      elsif @array_member2[i] then
+#        am2[i] = @array_member2[i].clone_for_composite( ct_name, cell_name, locale, false )
+        am2[i] = @array_member2[i].clone_for_composite( ct_name, cell_name, locale, true )
+        am[i] = am2[i].get_rhs
       else
         # 以前のエラーで array_member2[i] は nil になっている
@@ -5814,5 +6329,5 @@
 
       # debug
-      dbgPrint "clone_array_member: #{@name} #{am2[i]} #{array_member2[i]}\n"
+      dbgPrint "clone_array_member: #{@name} subsript=#{i} #{am2[i]} #{@array_member2[i]}\n"
 
       i += 1
@@ -5840,4 +6355,10 @@
     dbgPrint "Join#set_cloned: #{@name}  prev owner: #{@owner.get_name} new owner: #{owner.get_name}\n"
     @owner = owner
+    if @array_member2 then
+      @array_member2.each{ |join|
+        dbgPrint "Joinarray#set_cloned: #{@name}  prev owner: #{join.get_owner.get_name} new owner: #{owner.get_name}\n"
+        join.set_owner owner
+      }
+    end
   end
 
@@ -5905,10 +6426,12 @@
         if j then
           (indent+2).times { print "  " }
-          puts "[#{i}]: #{j.get_name}  id: #{j}"
+          puts "[#{i}]: #{j.get_name}  id: #{j} owner=#{j.get_owner.get_name}"
           j.get_rhs.show_tree(indent+3)
-          (indent+3).times { print "  " }
-          puts "cell global name: #{j.get_cell_global_name}"
-          (indent+3).times { print "  " }
-          puts "port global name: #{j.get_port_global_name}"
+#          (indent+3).times { print "  " }
+#          puts "cell global name: #{j.get_cell_global_name}"
+#          puts "cell global name: #{j.get_rhs_cell.get_global_name}"
+#          (indent+3).times { print "  " }
+#          puts "port global name: #{j.get_port_global_name}"
+#          puts "port global name: #{j.get_rhs_port.get_name}"
         else
           (indent+2).times { print "  " }
@@ -6235,5 +6758,5 @@
 end
 
-#== Domain
+#== DomainType
 #
 # region の domain を記憶するクラス
@@ -6256,5 +6779,5 @@
     @name = name
     @plugin_name = (name.to_s + "Plugin").to_sym
-    load_plugin( @plugin_name, DomainPlugin )
+    plClass = load_plugin( @plugin_name, DomainPlugin )
     @region = region
     @option = option
@@ -6272,5 +6795,7 @@
     if ! @plugin then
       pluginClass = Object.const_get @plugin_name
+      return if pluginClass == nil
       @plugin = pluginClass.new( @region, @name, @option )
+      @plugin.set_locale @locale
     end
   end
@@ -6290,5 +6815,5 @@
   end
 
-  #== Domain リージョンの Hash を得る
+  #== DomainType リージョンの Hash を得る
   # @@domain_regions の説明参照
   def self.get_domain_regions
@@ -6302,4 +6827,10 @@
   def get_option
     @option
+  end
+
+  #== DomainType#ドメイン種別を得る
+  #return::Symbol :kernel, :user, :OutOfDomain
+  def get_kind
+    @plugin.get_kind
   end
 
@@ -6363,4 +6894,5 @@
 
     if @@domain_name then
+      dbgPrint "Region=#{name} domain_type=#{@@domain_name} option=#{@@domain_option}\n"
       domain_option = CDLString.remove_dquote @@domain_option.to_s
       @domain_type = DomainType.new( self, @@domain_name, domain_option )
@@ -6401,5 +6933,6 @@
 
         # 再出現時に specifier が指定されているか？
-        if( @in_through_list.length != 0 || @out_through_list.length != 0 || @to_through_list.length != 0 || @region_type != nil )then
+        if( @in_through_list.length != 0 || @out_through_list.length != 0 || @to_through_list.length != 0 ||
+            @region_type != nil || @domain_type != nil )then
           cdl_error( "S1140 $1: region specifier must place at first appearence" , name )
         end
@@ -6610,4 +7143,10 @@
   end
 
+  #== Region# ルートリージョン
+  # ルートリージョンは、namespace のルートと同じインスタンス
+  def selfget_root
+    Namespace.get_root
+  end
+
   def next_in_through_count
     @in_through_count += 1
@@ -6643,10 +7182,16 @@
   #=== Region# through プラグインで、この region から cell_name.port_name へのプラグインオブジェクトを登録
   # mikan namesppace 対応 (cell_name)
-  def add_cell_port_through_plugin( cell_name, port_name, through_plugin_object )
-    @cell_port_throug_plugin_list[ "#{cell_name}.#{port_name}" ] = through_plugin_object
-  end
-
-  def find_cell_port_through_plugin( cell_name, port_name )
-    return @cell_port_throug_plugin_list[ "#{cell_name}.#{port_name}" ]
+  def add_cell_port_through_plugin( cell_name, port_name, subscript, through_plugin_object )
+    if subscript then
+      subscript = '[' + subscript.to_s + ']'
+    end
+    @cell_port_throug_plugin_list[ "#{cell_name}.#{port_name}#{subscript}" ] = through_plugin_object
+  end
+
+  def find_cell_port_through_plugin( cell_name, port_name, subscript )
+    if subscript then
+      subscript = '[' + subscript.to_s + ']'
+    end
+    return @cell_port_throug_plugin_list[ "#{cell_name}.#{port_name}#{subscript}" ]
   end
 
@@ -6779,4 +7324,72 @@
 end
 
+#== Importable class
+# this module is included by Import_C and Import
+module Importable
+#@last_base_dir::String
+
+  #=== Importable#find_file
+  #file::String : file name to find
+  #return::String | Nil: path to file or nil if not found
+  #find file in 
+  def find_file file
+    $import_path.each{ |path|
+      if path == "."
+        pt = file
+      else
+        pt = "#{path}/#{file}"
+      end
+      if File.exist?( pt )
+        if ! $base_dir[ Dir.pwd ]
+          $base_dir[ Dir.pwd ] = true
+        end
+        if $verbose then
+          print "#{file} is found in #{path}\n"
+        end
+        @last_base_dir = nil
+        dbgPrint "base_dir=. while searching #{file}\n"
+        return pt
+      end
+    }
+
+    $base_dir.each_key{ |bd|
+      $import_path.each{ |path|
+#        if path =~ /\A\// || path =~ /\A[a-zA-Z]:/
+          pt = "#{path}/#{file}"
+#        else
+#          pt = "#{bd}/#{path}/#{file}"
+#        end
+        begin
+          Dir.chdir $run_dir
+          Dir.chdir bd
+          if File.exist?( pt )
+            if $verbose then
+              print "#{file} is found in #{bd}/#{path}\n"
+            end
+            @last_base_dir = bd
+            dbgPrint "base_dir=#{bd} while searching #{file}\n"
+            $base_dir[ bd ] = true
+            return pt
+          end
+        rescue
+        end
+      }
+    }
+    @last_base_dir = nil
+    dbgPrint "base_dir=. while searching #{file}\n"
+    return nil
+  end
+
+  def get_base_dir
+    return @last_base_dir
+    $base_dir.each{ |bd, flag|
+      if flag == true
+        return bd
+      end
+    }
+    return nil
+  end
+end
+
 class Import_C < Node
 
@@ -6785,4 +7398,6 @@
   @@header_list2 = []
   @@define_list = {}
+
+  include Importable
 
   #=== Import_C# import_C の生成（ヘッダファイルを取込む）
